'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bisuReactLoading = require('bisu-react-loading');

var _bisuReactLoading2 = _interopRequireDefault(_bisuReactLoading);

var _print = require('react-icons/lib/md/print');

var _print2 = _interopRequireDefault(_print);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PrintContainer = function (_Component) {
  _inherits(PrintContainer, _Component);

  function PrintContainer(props) {
    _classCallCheck(this, PrintContainer);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this._print = function () {
      window.print();
    };

    _this._close = function () {
      window.close();
    };

    _this._setReady = function () {
      _this.setState({ isReady: true });
    };

    _this._setError = function (error) {
      _this.setState({ error: error });
    };

    _this.state = {
      isReady: props.isReady,
      error: null
    };
    return _this;
  }

  PrintContainer.prototype.componentDidMount = function componentDidMount() {
    if (this.props.autoPrint) {
      window.print();
    }
  };

  PrintContainer.prototype._renderToolbar = function _renderToolbar() {
    var _state = this.state,
        isReady = _state.isReady,
        error = _state.error;

    if (error) {
      return _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-6 col-sm-offset-3' },
          _react2.default.createElement('hr', null),
          _react2.default.createElement(
            'p',
            { className: 'alert alert-danger' },
            error
          )
        )
      );
    } else {
      if (!isReady) {
        return _react2.default.createElement(_bisuReactLoading2.default, null);
      } else {
        return this._renderButtons();
      }
    }
  };

  PrintContainer.prototype._renderButtons = function _renderButtons() {
    return _react2.default.createElement(
      'div',
      { className: 'print-header text-right hidden-print' },
      _react2.default.createElement(
        'button',
        {
          type: 'button',
          onClick: this._close,
          className: 'btn btn-sm btn-light'
        },
        'Close'
      ),
      ' ',
      _react2.default.createElement(
        'button',
        {
          type: 'button',
          onClick: this._print,
          className: 'btn btn-sm btn-warning'
        },
        _react2.default.createElement(_print2.default, null),
        ' Print'
      )
    );
  };

  PrintContainer.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'bisu--print-container' },
      this._renderToolbar(),
      this.props.children({
        setReady: this._setReady,
        setError: this._setError
      })
    );
  };

  return PrintContainer;
}(_react.Component);

exports.default = PrintContainer;
module.exports = exports['default'];